
package de.ivu.elect.business.veranstaltung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.veranstaltung.entity.Teilnahme;

@RequestScoped
@Named(TeilnahmeConversationSelect.COMPONENT_NAME)
public class TeilnahmeConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "teilnahmeConversationSelect";

  @Inject
  protected transient TeilnahmeExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(TeilnahmeConversationStore.class)
  protected transient TeilnahmeConversationStore conversationStore;

  public TeilnahmeConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Teilnahme getEntity() {
    return getEntityInternal();
  }

  private Teilnahme getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Teilnahme entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.veranstaltung.entity.TeilnahmePK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Teilnahme entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.veranstaltung.entity.TeilnahmePK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Teilnahme attach(Teilnahme entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Teilnahme attach( de.ivu.elect.business.veranstaltung.entity.TeilnahmePK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
